/* 8bit u-law / 8kHz  data ñ˷Ҥ
 * shige
 * 02/16 1999 ver 0.1
 * 03/09 1999 ver 0.2
 * 05/02 2000 ver 0.3
 * auconn.c
 *
 * $Id: auconn.c,v 1.22 2003-12-23 22:54:22+09 shige Exp $
 */
/* 02/16 1999
 * 1)	椯椯ϿʤΤĤʤѤˤ
 * 03/09 1999
 * 2)	file  full path ͿƤȤ shell  command line 
 * 	buffer θ³롣äơsearch path ꤹ褦ˤ롣
 * 	ϡ file  path Ǥʤdata format ʤɿ 
 *	command line opetion 񤱤褦ˤ롣ޤǳĥ
 *	ʤ
 * 05/02 2000
 * 3)	strtok  csrc/test/teststrt.c ˤ⤢褦ˡconstant ʸ
 *	ФƤ Bus error
 */
#ifndef __AUCONN_C__
#define __AUCONN_C__

#include "auconn.h"

/* ########## main routine ########## */
int main(int argc,char *argv[],char *env[])
{
    int j,j0,k,N,Num;
    Snddata *snddata;
    WAVdata *wavdata;
    AIFFdata *aiffdata;
    int fblock,dataonly=0;
    int Nlen,olen,bs,ch,byte,blocks,len,addsp;
    double smplrate;
    double times;
    int form;
    ConnOpt opt[Maxdatanum+1];
    int fnamepos[Maxdatanum];

    if((form=setdefaultSndForm(argv[0]))==E_UNKNOWN){
	usage(argv[0],form); return Exit_noarg;
    }
    initdefvar(form);
    if(argc<2){ usage(argv[0],form); return Exit_noarg; }
    if((j=getarg(argc,argv,env,&fblock,&dataonly,&opt[0]))<0){
	usage(argv[0],form); return -j;
    }
    if(listonly){
	for(k=j;k<argc;k++){
	    if(*argv[k]=='-') continue;
	    if(strcmp(argv[k-1],"-S")==0 || strcmp(argv[k-1],"-Lb")==0 
	       || strcmp(argv[k-1],"-Ls")==0) continue; 
	    if((tmpfile1=fopenpathlist(argv[k]))!=NULL
	       ||(NULLFname!=NULL && (tmpfile1=fopenpathlist(NULLFname))!=NULL))
	      fclose(tmpfile1);
	}
	return No_err;
    }
    j0=j;
    if(argc-1-j0+1>Maxdatanum){ usage(argv[0],form); return Exit_toomanyarg; }
    N=argc-1-j0+1;
    /* 1 ܤ file 򳫤 */
    if((tmpfile1=fopenpathlist(argv[j0]))==NULL){
	if(NULLFname==NULL||(tmpfile1=fopenpathlist(NULLFname))==NULL)
	  return Exit_openpathfile;
	else argv[j0]=NULLFname;
    }
    switch(form){
    case E_AU:
	if((snddata=(Snddata *)malloc(sizeof(Snddata)*N))==NULL)
	  return Exit_getmaxdata;
	if(getSndheader(tmpfile1,&snddata[0])<0) return Exit_getSndheader;
	smplrate=snddata[0].smplrate;
	break;
    case E_WAV:
	if((wavdata=(WAVdata *)malloc(sizeof(WAVdata)*N))==NULL)
	  return Exit_getmaxdata;
	if(getWAVheader(tmpfile1,&wavdata[0])<0) return Exit_getWAVheader;
	smplrate=wavdata[0].smplrate;
	break;
    case E_AIFF:
	if((aiffdata=(AIFFdata *)malloc(sizeof(AIFFdata)*N))==NULL)
	  return Exit_getmaxdata;
	if(getAIFFheader(tmpfile1,&aiffdata[0])<0) return Exit_getAIFFheader;
	smplrate=(aiffdata[0].smplrate).x;
	break;
    }
    fclose(tmpfile1);
    /* 2 ܰʹߤ file 򳫤 header  1 ܤΤΤ */
    Num=1;
    fnamepos[0]=j0;
    if(!fblock && opt[0].len>0) opt[0].len=opt[0].len*smplrate/1000;
    cpConnOpt(&opt[Num],&opt[Num-1]);
    for(j=j0+1;j<argc;j++){
	if(*argv[j]=='-'){
	    int j1=j; char *s=argv[j];

	    switch(*(++argv[j])){
	    case 'L':
		if(getL(argc,argv,&j,&fblock,&(opt[Num].addsp),
			&(opt[Num].len))<0)
		   return Exit_getarg;
		if(!fblock) opt[Num].len=opt[Num].len*smplrate/1000;
		break;
	    case 'S':
		if(getS(argc,argv,&j,&(opt[Num].times))<0) return Exit_getarg;
		break;
	    default: return Exit_unknownarg;
	    }
	    argv[j1]=s;
	}
	else{
	    if((tmpfile1=fopenpathlist(argv[j]))==NULL){ 
		if(NULLFname==NULL||(tmpfile1=fopenpathlist(NULLFname))==NULL)
		  return Exit_openpathfile;
		else argv[j]=NULLFname;
	    }
	    Num++;
	    fnamepos[Num-1]=j;
	    switch(form){
	    case E_AU:
		if(getSndheader(tmpfile1,&snddata[Num-1])<0) 
		  return Exit_getSndheader;
		if(chSndheader(&snddata[Num-1],&snddata[0])<0) 
		  return Exit_chSndheader;
		break;
	    case E_WAV:
		if(getWAVheader(tmpfile1,&wavdata[Num-1])<0) 
		  return Exit_getWAVheader;
		if(chWAVheader(&wavdata[Num-1],&wavdata[0])<0) 
		  return Exit_chWAVheader;
		break;
	    case E_AIFF:
		if(getAIFFheader(tmpfile1,&aiffdata[Num-1])<0) 
		  return Exit_getAIFFheader;
		if(chAIFFheader(&aiffdata[Num-1],&aiffdata[0])<0) 
	      return Exit_chAIFFheader;
		break;
	    }
	    fclose(tmpfile1);
	    cpConnOpt(&opt[Num],&opt[Num-1]);
	}
    }
    /*  */
    if(!dataonly) 
	switch(form){
	case E_AU:
	    putallheader4(stdout,snddata,Num,opt); break;
	case E_WAV:
	    putallWAVheader4(stdout,wavdata,Num,opt); break;
	case E_AIFF:
	    putallAIFFheader4(stdout,aiffdata,Num,opt); break;
	}
    switch(form){
    case E_AU: 
	bs=1; ch=1; byte=1; break;
    case E_WAV:
	bs=wavdata[0].blocksize; ch=wavdata[0].channel; byte=bs/ch; break;
    case E_AIFF:
	bs=aiffdata[0].flamesize; ch=aiffdata[0].channel; byte=bs/ch; break;
    }
    for(j=1;j<=Num;j++){
	if((tmpfile1=fopenpathlist(argv[fnamepos[j-1]]))==NULL)
	  return Exit_openpathfile;
	switch(form){
	case E_AU: Nlen=snddata[j-1].datalen/bs; break;
	case E_WAV: Nlen=wavdata[j-1].datalen/bs; break;
	case E_AIFF: Nlen=aiffdata[j-1].datalen/bs; break;
	}
	len=opt[j-1].len;
	addsp=opt[j-1].addsp;
	times=opt[j-1].times;
	if(times>0.0 && times!=1.0) Nlen=Nlen/times;
	olen=(len>0 && len<Nlen)? len : Nlen;
	if(len>0 && Nlen<len && addsp<0){
	    blocks=(len-Nlen)*ch;
	    for(k=1;k<=blocks;k++)
	      switch(form){
	      case E_AU: putchar(AUNULL); break;
	      case E_WAV:
		  if(byte==1) putchar(WAV8NULL);
		  else writelittleito2byte(stdout,WAV16NULL);
		  break;
	      case E_AIFF:
		  if(byte==1) putchar(AIFF8NULL);
		  else writeito2byte(stdout,AIFF16NULL);
		  break;
	      }
	}
	/* Ѵ (len>0 => min{Nlen,len}, len<0 => Nlen) */
	switch(form){
	case E_AU: 
	    puttrans(tmpfile1,stdout,&snddata[j-1],olen,times); 
	    break;
	case E_WAV: 
	    puttransWAV(tmpfile1,stdout,&wavdata[j-1],olen,times); 
	    break;
	case E_AIFF: 
	    puttransAIFF(tmpfile1,stdout,&aiffdata[j-1],olen,times); 
	    break;
	}
	if(len>0 && Nlen<len && addsp>0){
	    blocks=(len-Nlen)*ch;
	    for(k=1;k<=blocks;k++)
	      switch(form){
	      case E_AU: putchar(AUNULL); break;
	      case E_WAV:
		  if(byte==1) putchar(WAV8NULL);
		  else writelittleito2byte(stdout,WAV16NULL);
		  break;
	      case E_AIFF:
		  if(byte==1) putchar(AIFF8NULL);
		  else writeito2byte(stdout,AIFF16NULL);
		  break;
	      }
	}
	fclose(tmpfile1);
	tmpfile1=NULL;
    }
    return No_err;
}

void cpConnOpt(ConnOpt *new,ConnOpt *org)
{
    new->len=org->len;
    new->addsp=org->addsp;
    new->times=org->times;
}

/* ########## get-argument and initialize for {au,wav,aiff}conn ########## */
int setdefaultSndForm(char *commname)
{
    int len1,len2,j;

    len1=strlen(commname);
    for(j=0;j<=2;j++){
        if((len2=strlen(CommandNames[j]))<=len1){
            if(len2==len1 && strcmp(CommandNames[j],commname)==0) return j;
            if(len2<len1 && strcmp(CommandNames[j],commname+len1-len2)==0
                && *(commname+len1-len2-1)=='/') return j;
        }
    }
    return E_UNKNOWN;
}

int getarg(int argc,char *argv[],char *env[],int *fblock,int *dataonly,
	   ConnOpt *opt)
{
    int j,inoption,ret;
    char c;

    inithome(env);
    undefs="undefined"; NULLFname=undefs;
    j=1;
    opt->len=-1; opt->addsp=0; opt->times=-1.0;
    if(*argv[j]=='-'){
	c=*(++argv[j]);
	while(1){
	    switch(c){
	    case 'p':
		if(*++argv[j]=='\0' && ++j>=argc) return -Exit_noarg;
		if(addstr2pathlist(argv[j])<0) return -Exit_addstr2pathlist;
		inoption=0;
		break;
	    case 'e':
		if(*++argv[j]=='\0' && ++j>=argc) return -Exit_noarg;
		if(addstr2extlist(argv[j])<0) return -Exit_addstr2extlist;
		inoption=0;
		break;
	    case 'f':
		if(*++argv[j]=='\0' && ++j>=argc) return -Exit_noarg;
		DEFAULTConffname=argv[j];
#if 0
		if(addfile2list(argv[j])<0) return -Exit_addfile2list;
#endif /* 0 */
		inoption=0;
		break;
	    case 'q':
		verbose=0;
		inoption=1;
		break;
	    case 'l':
		listonly=1;
		inoption=1;
		break;
	    case 'r':
		*dataonly=1;
		inoption=1;
		break;
	    case 'n':
		if(*++argv[j]=='\0' && ++j>=argc) return -Exit_noarg;
		if(*argv[j]=='-') NULLFname=NULL;
		else NULLFname=argv[j];
		inoption=0;
		break;
	    case 'L':
		if((ret=getL(argc,argv,&j,fblock,&(opt->addsp),&(opt->len)))<0)
		   return ret;
		inoption=0;
		break;
	    case 'S':
		if((ret=getS(argc,argv,&j,&(opt->times)))<0) return ret;
		inoption=0;
		break;
	    case 'h':
		return -Exit_help;
	    default:
		return -Exit_unknownarg;
	    }
	    if(inoption && (c=*(++argv[j]))!='\0') continue;
	    if(++j>=argc) return -Exit_noarg;
	    if(*argv[j]!='-') break;
	    c=*(++argv[j]);
	}
    }
    if(initpathextlist(env)!=No_err) return -Exit_envdefault;
    /* j  argc-1  au file ̾
     * option ˤäƤ file ̾ stdin 餦äƤΤ⤤⤷
     * ʤ
     */
#ifdef DEBUG4
    putallpathlist();
    putallextlist();
#endif
    return j;
}

void initdefvar(int format)
{
    if(format==E_AU){
	DEFAULTExtlist=AU_Extlist;
	DEFAULTPathlist=AU_Pathlist;
	DEFAULTConffname=AU_Conffname;
	DEFAULTExtEnvname=AU_ExtEnvname;
	DEFAULTPathEnvname=AU_PathEnvname;
	DEFAULTNULLFEnvname=AU_NULLFEnvname;
    }
    else if(format==E_WAV){
	DEFAULTExtlist=WAV_Extlist;
	DEFAULTPathlist=WAV_Pathlist;
	DEFAULTConffname=WAV_Conffname;
	DEFAULTExtEnvname=WAV_ExtEnvname;
	DEFAULTPathEnvname=WAV_PathEnvname;
	DEFAULTNULLFEnvname=WAV_NULLFEnvname;
    }
    else if(format==E_AIFF){
	DEFAULTExtlist=AIFF_Extlist;
	DEFAULTPathlist=AIFF_Pathlist;
	DEFAULTConffname=AIFF_Conffname;
	DEFAULTExtEnvname=AIFF_ExtEnvname;
	DEFAULTPathEnvname=AIFF_PathEnvname;
	DEFAULTNULLFEnvname=AIFF_NULLFEnvname;
    }
}

/* ##### -L option ؿ ##### */
int getL(int argc,char *argv[],int *j,int *fblock,int *addsp,int *len)
{
    int k;

    if(*++argv[*j]=='b') *fblock=1;
    else if(*argv[*j]=='s') *fblock=0;
    else return -Exit_invalid_arg;

    if(*++argv[*j]=='\0' && ++*j>=argc) return -Exit_noarg;
    if((k=strlen(argv[*j]))<=0) return -Exit_invalid_arg;

    if(*(argv[*j]+k-1)=='+'){ *addsp=1; *(argv[*j]+k-1)='\0'; }
    else if(*(argv[*j]+k-1)=='-'){ *addsp=-1; *(argv[*j]+k-1)='\0'; }
    else *addsp=0;

    if((*len=atoi(argv[*j]))<=0) return -Exit_invalid_arg;
    return No_err;
}

/* ##### -S option ؿ ##### */
int getS(int argc,char *argv[],int *j,double *times)
{
    if(*++argv[*j]=='\0' && ++*j>=argc) return -Exit_noarg;
    if((*times=atof(argv[*j]))<Mintimes) return -Exit_invalid_arg;
    return No_err;
}

/* ##### usage() for {au,aiff,wav}conn ##### */
void usage(char *comname,int form)
{
    char *fs[]={"au","wav","aiff"};
    char *mess[]={
	"Usage: %s [options] [%sfile] ([%sfile] ...)",
	" options:",
	"   -p[path]: %s file ѥ",
	"             (default=\"%s\")",
	"   -e[ext] : %s file ĥ",
	"             (default=\"%s\")",
	"   -f[file]: ե (default=%s)",
	"   -l      : %s file ΥꥹȤΤɽ",
	"   -n[path]: nullfile ե̾ (default=ʤ)",
	"   -L[str] : ƲǤĹ (default=ĹϹͤˤĤʤ)",
	"             ([str] = (b|s)[Ĺ](+|-))",
	"   -S[num] : [num] ® (default=1.0)",
	/* "   -au/wav/aiff: եޥåȤλ", */
	"   -r      : եإåϤʤ (default=Ϥ)",
	"   -q      : 顼ɽʤ",
	"   -h      : Υå",
	" ",
	" [1] ѥĥҤϡ (':') ǥߥȤʣǤ롣",
	" [2] եˤϡǥեȤθѥĥҤǤ롣",
	"     եǤ '#' ǻϤޤԤϥȤȸʤ졢Ԥ"
	"̵뤵롣",
	"     ԤΥեޥåȤ",
	"       [] [ꥹ]",
	"     Ǥꡢ[] ϸѥ \"path\", ĥҤ \"ext\" Ȥ롣",
	"     եǤ ':' ͭĹʤϡƱ"
	"ʣ",
	"     Ԥ񤱤Ф褤",
	" [3] ѥĥҤϡ줾Ķѿ %s"
	", %s ⻲Ȥ롣",
	"     ̤ͥ",
	"       ޥɥ饤 > Ķѿ > ե > ǥե",
	"     ν (ǥեȤϥѥΥǥեȤǡ"
	"ץ",
	"     βս default: Ȥƽ񤫤Ƥ)",
	" [4] nullfile ϡꤷե뤬ʤäѤ˻Ȥ"
	"ե",
	"     (̵ʤ)ΥեФƤ⸡ѥĥҤ"
	"ͭ",
	"     default Ǥ nullfile ϻѤ顼Ȥ롣"
	"Ķѿ %s Ǥ",
	"     ꡢեǤΥ \"nullfile\" ˤġ",
	"     ʤե̾Ȥ \"-\" ꤷ nullfile "
	"Ѥʤ",
	" [5] -L[str] ꤹȡƲǤꤷĹ·ƽϤ롣"
	"[str] ",
	"       b[num],b[num]+,b[num]-(==[num] block)",
	"       s[num],s[num]+,s[num]-(==[num] ߥ)",
	"      6 ̤ηǻǤ롣ǤĹĹĹ"
	"åȤ졢",
	"     Ĺû '+', '-' ǸˤĤƤ̵"
	"ʬä",
	"     ('+': ̵, '-': Ƭ̵) ŪĹ [num]"
	"·롣",
	" [6] -S[num]  [num]>1.0 ΤȤ®[num]<1.0 ΤȤ٤"
	"ꡢ",
	"     ˱ƲѲ롣",
	" [7] -L/-S ץϡե˻ꤹ뤳ȤǤ"
	"ξ硢",
	"     ϤʹߤΥե˱ƶ롣",
	NULL
    };
    int j;

    if(form==E_UNKNOWN) form=0;
    for(j=0;mess[j]!=NULL;j++){
	if(j==0) fprintf(stderr,mess[j],comname,fs[form],fs[form]);
	else if(j==2 || j==4 || j==7) fprintf(stderr,mess[j],fs[form]);
	else if(j==3) fprintf(stderr,mess[j],DEFAULTPathlist);
	else if(j==5) fprintf(stderr,mess[j],DEFAULTExtlist);
	else if(j==6) fprintf(stderr,mess[j],DEFAULTConffname);
	else if(j==24) 
	  fprintf(stderr,mess[j],DEFAULTPathEnvname,DEFAULTExtEnvname);
	else if(j==31) fprintf(stderr,mess[j],DEFAULTNULLFEnvname); 
	else fprintf(stderr,mess[j]);
	fputc('\n',stderr); 
    }
}

#endif /* __AUCONN_C__ */
