/* WAV file ôʬΥإåե
 * shige
 * 10/01 2000
 * wavio.h
 * 
 * $Id: wavio.h,v 1.6 2003-12-22 23:37:21+09 shige Exp $
 */
#ifndef __WAVIO_H__
#define __WAVIO_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "chunk.h"
#include "error.h"
#include "fileio.h"
#include "cstruct.h"

typedef struct {
    short int fmcode;
    short int channel;
    long int smplrate;
    long int bytepersec;
    short int blocksize;
    short int bitpersmpl;
    /* short int extendedsize; */
    long int hlen;
    long int datalen;
} WAVdata;

/* ̵ǡ */
#define WAV8NULL (0x7f)
#define WAV16NULL (0xfff8)
/* WAVSCALE*bit: |粻|
 * WAVPOS*bit: linear data shift 
 */
#define WAVPOS8bit 127
#define WAVSCALE8bit 125.0
#define WAVPOS16bit 0
#define WAVSCALE16bit 32764.0

#define WAVMAXChannel 8

#ifdef __WAVIO_C__
# define EXTERN_WAVIO 
#else
# define EXTERN_WAVIO extern 
#endif

EXTERN_WAVIO int getWAVheader(FILE *file,WAVdata *wd);
EXTERN_WAVIO int getWAVinfo(FILE *file,WAVdata *wd,Chunk *Ch);
EXTERN_WAVIO int chWAVheader(WAVdata *wd1,WAVdata *wd2);
EXTERN_WAVIO void putallWAVheader(FILE *file,WAVdata *wd,int N);
EXTERN_WAVIO void putallWAVheader2(FILE *file,WAVdata *wd,int N,int len,
				   int addsp);
EXTERN_WAVIO void putallWAVheader3(FILE *file,WAVdata *wd,int N,int len,
				   int addsp,double times);
EXTERN_WAVIO void putallWAVheader4(FILE *file,WAVdata *wd,int N,ConnOpt *opt);
EXTERN_WAVIO void puttransWAV(FILE *infile,FILE *outfile,WAVdata *wd,int olen,
			      double times);

#endif /* __WAVIO_H__ */
